function love.load()
  love.graphics.setFont(12)
  text = "Nothing yet"
  mouseConditionText = ""
	width = love.graphics.getWidth()
	height = love.graphics.getHeight()
	mgreen = 100

	TRAIL = 100
	SPACING = .01
	counter = 0

  array = {}
end

function love.update(dt)
  mouse_x, mouse_y = love.mouse.getPosition()
  
  counter = counter + dt
  if counter >= SPACING then
  	counter = 0
    table.insert(array, {
      xpos = mouse_x;
      ypos = mouse_y;
      rc = 255 * mouse_x / width;
      gc = mgreen;
      bc = 255 * mouse_y / height;
      })
  end

  if table.getn(array) > TRAIL then
  	table.remove(array, 1)
  end
  
  local cur = array[table.getn(array)]
  text = string.format("%.2f", counter)..
    "\n[".. table.getn(array)..
    "]\nrc = "..string.format("%.2f", cur.rc)..
    "\ngc = "..string.format("%.2f", cur.gc)..
    "\nbc = "..string.format("%.2f", cur.bc)
end

function love.draw()
  for i, v in ipairs(array) do
    local calpha = 255 * i/TRAIL
    love.graphics.setColor(v.rc, v.gc, v.bc, calpha)
    love.graphics.circle("fill", v.xpos, v.ypos, 32, 50)
  end
  
  love.graphics.setColor(255, 255, 255, 255)
  love.graphics.print("Mouse X: ".. mouse_x.." Mouse Y: "..mouse_y, 30, 30)
  love.graphics.print(mouseConditionText, 30, 45)
  love.graphics.print(text, 330, 300)
  love.graphics.print(love.timer.getFPS().."FPS", 30, height-30)
end

function love.keypressed(key)
  if key == 'h' then
    love.mouse.setVisible(not love.mouse.isVisible())
  end
  if key == "escape" or key == 'q' then
    love.event.push('q')
  end
end

function love.mousepressed(x, y, button)
  if button == 'l' then
    mgreen = (mgreen - 10 < 0 and 255) or (mgreen - 10)
    mouseConditionText = "LeftMouseButton is pressed. mgreen = "..mgreen
  end
  if button == 'r' then
	  mgreen = (mgreen + 10 > 255 and 0) or (mgreen + 10)
    mouseConditionText = "RightMouseButton is pressed. mgreen = "..mgreen
  end
end

function love.mousereleased(x, y, button)
  if button == 'l' then
    mouseConditionText = "LeftMouseButton is released. mgreen = "..tostring(mgreen)
  end
  if button == 'r' then
    mouseConditionText = "RightMouseButton is released. mgreen = "..tostring(mgreen)
	end
end
